diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 858cdf7e0..e5057d4bf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -1,32 +1,30 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.generate.feature.WorldFeatureOre;
+import net.minecraft.core.world.WorldSource;
 
-import java.util.HashMap;
-import java.util.Map;
 import java.util.Random;
 
 public class BlockLogicOreRedstone extends BlockLogic
 {
-    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public static WorldFeatureOre.OreMap variantMap = new WorldFeatureOre.OreMap();
     private final boolean illuminated;
     private final Block<?> normalBlock;
     private final Block<?> illuminatedBlock;
     public BlockLogicOreRedstone(Block<?> block, Block<?> parentBlock, Material material, boolean illuminated, Block<?> normalBlock, Block<?> illuminatedBlock)
     {
         super(block, material);
-        if(illuminated)
-        {
-            block.setTicking(true);
-        }
         this.illuminated = illuminated;
         this.normalBlock = normalBlock;
         this.illuminatedBlock = illuminatedBlock;
@@ -48,6 +46,17 @@ public class BlockLogicOreRedstone extends BlockLogic
         super.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
+    @Override
+    public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final Player player, final Side side, final double xHit, final double yHit) {
+        lightRedstone(world, x, y, z);
+        return false;
+    }
+
+    @Override
+    public void onActivatorInteract(final World world, final int x, final int y, final int z, final TileEntityActivator activator, final Direction direction) {
+        lightRedstone(world, x, y, z);
+    }
+
     @Override
     public void onEntityWalking(World world, int x, int y, int z, Entity entity)
     {
@@ -61,7 +70,8 @@ public class BlockLogicOreRedstone extends BlockLogic
         spawnParticles(world, x, y, z);
         if (!illuminated)
         {
-        	world.setBlockWithNotify(x, y, z, illuminatedBlock.id());
+            world.scheduleBlockUpdate(x, y, z, illuminatedBlock.id(), 20 + world.rand.nextInt(9 * 20));
+            world.setBlockWithNotify(x, y, z, illuminatedBlock.id());
         }
     }
 
@@ -74,6 +84,21 @@ public class BlockLogicOreRedstone extends BlockLogic
         }
     }
 
+    @Override
+    public boolean getSignal(final WorldSource worldSource, final int x, final int y, final int z, final Side side) {
+        return this.illuminated;
+    }
+
+    @Override
+    public boolean getDirectSignal(final World world, final int x, final int y, final int z, final Side side) {
+        return false;
+    }
+
+    @Override
+    public boolean isSignalSource() {
+        return true;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index d97bc0ea8..9781fe381 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -186,7 +186,7 @@ public class BlockLogicRail extends BlockLogic {
         }
 
         if(isConnectedPoweredRail2(world, nextX, nextY, nextZ, forward, distance, axis)) { return true; }
-        return railDirection.isStraight() && isConnectedPoweredRail2(world, nextX, nextY - 1, nextZ, forward, distance, axis);
+        return isConnectedPoweredRail2(world, nextX, nextY - 1, nextZ, forward, distance, axis);
     }
 
     private boolean isConnectedPoweredRail2(World world, int x, int y, int z, boolean forward, int distance, Axis axis) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 0a59a9ea1..dc45de160 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -7,14 +7,16 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockLogicSign extends BlockLogic
+public class BlockLogicSign extends BlockLogic implements IPaintable
 {
+    public static final int MASK_SIDE = 0b0000_1111;
     public static final int SIDE_NORTH = 2;
     public static final int SIDE_SOUTH = 3;
     public static final int SIDE_WEST = 4;
@@ -47,7 +49,7 @@ public class BlockLogicSign extends BlockLogic
         float top = 12.5f / 16f;
         float width = 16f / 16f;
         float thickness = 2.0f / 16f;
-        switch (world.getBlockMetadata(x, y, z)) {
+        switch (world.getBlockMetadata(x, y, z) & MASK_SIDE) {
             case SIDE_NORTH:
                 return AABB.getTemporaryBB(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
             case SIDE_SOUTH:
@@ -85,7 +87,7 @@ public class BlockLogicSign extends BlockLogic
             }
         } else
         {
-            switch (world.getBlockMetadata(x, y, z)) {
+            switch (world.getBlockMetadata(x, y, z) & MASK_SIDE) {
                 case SIDE_NORTH:
                     isUnstable = !world.getBlockMaterial(x, y, z + 1).isSolid();
                     break;
@@ -125,7 +127,7 @@ public class BlockLogicSign extends BlockLogic
                 }
                 player.addStat(Achievements.LIGHT_SIGN, 1);
                 return true;
-            } else if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DYE.id) {
+            } else if (player.getHeldItem() != null && (player.getHeldItem().itemID == Items.DYE.id || player.getHeldItem().itemID == Items.PAINTBRUSH.id)) {
                 return false;
             } else if (signEntity.isEditableBy(player)) {
                 player.displaySignEditorScreen(signEntity);
@@ -139,4 +141,10 @@ public class BlockLogicSign extends BlockLogic
     public int getPistonPushReaction(World world, int x, int y, int z) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        world.setBlockRaw(x, y, z, this.isFreeStanding ? Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id() : Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id());
+        world.setBlockMetadataWithNotify(x, y, z, color.blockMeta << 4 | (world.getBlockMetadata(x, y, z) & MASK_SIDE));
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
new file mode 100644
index 000000000..7860a4b14
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class BlockLogicSignPainted extends BlockLogicSign implements IPainted{
+    public static final int MASK_COLOR = 0b1111_0000;
+    public BlockLogicSignPainted(Block<?> block, boolean isFreeStanding) {
+        super(block, isFreeStanding);
+    }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta((meta & MASK_COLOR) >> 4);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & ~MASK_COLOR;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockMetadata(x, y, z, stripColorFromMetadata(world.getBlockMetadata(x, y, z)));
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        world.setBlockMetadataWithNotify(x, y, z, color.blockMeta << 4 | stripColorFromMetadata(world.getBlockMetadata(x, y, z)));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index ae5ae401e..f66b663ac 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -23,7 +23,7 @@ public class BlockLogicSponge extends BlockLogic
     {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte byte0 = 2;
-        if(world.dimension == Dimension.NETHER && isWet){
+        if((world.dimension == Dimension.NETHER || inHot(world, x, y, z)) && isWet){
             world.setBlockWithNotify(x, y, z, Blocks.SPONGE_DRY.id());
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
@@ -63,6 +63,23 @@ public class BlockLogicSponge extends BlockLogic
         return false;
     }
 
+    public boolean inHot(World world, int x, int y, int z){
+        Block<?> b;
+        if (Blocks.hasTag(b = world.getBlock(x + 1, y, z), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        if (Blocks.hasTag(b = world.getBlock(x - 1, y, z), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        if (Blocks.hasTag(b = world.getBlock(x, y + 1, z), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        if (Blocks.hasTag(b = world.getBlock(x, y - 1, z), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        if (Blocks.hasTag(b = world.getBlock(x, y , z + 1), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        if (Blocks.hasTag(b = world.getBlock(x, y , z - 1), BlockTags.IS_LAVA) || b == Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            return true;
+        return false;
+    }
+
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index f8b623f48..a92405fd2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -115,7 +115,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
         }
 
         Block<?> block = Blocks.getBlock(blockId);
-        if (block == null || block.isSignalSource()) {
+        if ((material != Material.metal && material != Material.steel && block != null && block.isSignalSource()) || ((material == Material.metal || material == Material.steel) && (block == null || block.isSignalSource()))) {
             int meta = world.getBlockMetadata(x, y, z);
             boolean isOpened = isTrapdoorOpen(meta);
             boolean isPowered = world.hasNeighborSignal(x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 28381d39e..6007f9098 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -994,6 +994,13 @@ public final class Blocks {
         .withSound(BlockSounds.WOOD).withHardness(1.0F).setStatParent(() -> Items.FLAG)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
 
+    public static final Block<BlockLogicSignPainted> SIGN_POST_PLANKS_OAK_PAINTED = register("sign.post.planks.oak.painted", "minecraft:block/sign_post_planks_oak_painted", 713, (BlockLogicSupplier<BlockLogicSignPainted>)(b) -> new BlockLogicSignPainted(b, true))
+        .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.SIGN)
+        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+    public static final Block<BlockLogicSignPainted> SIGN_WALL_PLANKS_OAK_PAINTED = register("sign.wall.planks.oak.painted", "minecraft:block/sign_wall_planks_oak_painted", 714, (BlockLogicSupplier<BlockLogicSignPainted>)(b) -> new BlockLogicSignPainted(b, false))
+        .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> SIGN_POST_PLANKS_OAK)
+        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+
     public static final Block<BlockLogicLayerSnow> LAYER_SNOW = register("layer.snow", "minecraft:block/layer_snow", 720, (BlockLogicSupplier<BlockLogicLayerSnow>)(b) -> new BlockLogicLayerSnow(b, Blocks.BLOCK_SNOW, Material.topSnow))
         .withSound(BlockSounds.CLOTH).withHardness(0.1F).withLitInteriorSurface(true)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.MINEABLE_BY_SHOVEL, BlockTags.OVERRIDE_STEPSOUND);
@@ -1362,4 +1369,10 @@ public final class Blocks {
         if (block == null) return false;
         return block.hasTag(tag);
     }
+
+    public static boolean hasTag(@Nullable Block<?> block, Tag<Block<?>> tag)
+    {
+        if (block == null) return false;
+        return block.hasTag(tag);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 1fceada04..f6e0a888b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -169,6 +169,7 @@ public class TileEntityTrommel extends TileEntity
     @Override
 	public void tick()
     {
+        boolean isClient = worldObj == null ? carriedBlock.holder.world.isClientSide : worldObj.isClientSide;
         if(nextToSieve > 4)
             nextToSieve = 1;
         boolean isBurning = burnTime > 0;
@@ -177,7 +178,7 @@ public class TileEntityTrommel extends TileEntity
         {
             burnTime--;
         }
-        if(worldObj == null || !worldObj.isClientSide)
+        if(!isClient)
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id()) {
             	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
diff --git a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
index f8250a653..b086c770c 100644
--- a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
@@ -73,6 +73,7 @@ public class LookupFuelFurnace {
 
 		addFuelEntry(Items.BOAT.id, 300);
 		addFuelEntry(Items.DOOR_OAK.id, 300);
+		addFuelEntry(Items.DOOR_OAK_PAINTED.id, 300);
 		addFuelEntry(Items.SIGN.id, 300);
 		addFuelEntry(Items.BOWL.id, 300);
 		addFuelEntry(Items.TOOL_CALENDAR.id, 300);
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 940c12e82..319bb69a7 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -83,6 +83,8 @@ public class Registries extends Registry<Registry<?>>
         ITEM_GROUPS.register("minecraft:nethercoal_ores", stackListOf(Blocks.ORE_NETHERCOAL_NETHERRACK));
         {
             List<ItemStack> plankStackList = new ArrayList<>();
+            List<ItemStack> signStackList = new ArrayList<>();
+            List<ItemStack> doorStackList = new ArrayList<>();
             List<ItemStack> chestStackList = new ArrayList<>();
             List<ItemStack> stairsStackList = new ArrayList<>();
             List<ItemStack> slabsStackList = new ArrayList<>();
@@ -94,6 +96,8 @@ public class Registries extends Registry<Registry<?>>
             List<ItemStack> invertedLampStackList = new ArrayList<>();
 
             plankStackList.add(Blocks.PLANKS_OAK.getDefaultStack());
+            signStackList.add(Items.SIGN.getDefaultStack());
+            doorStackList.add(Items.DOOR_OAK.getDefaultStack());
             chestStackList.add(Blocks.CHEST_PLANKS_OAK.getDefaultStack());
             stairsStackList.add(Blocks.STAIRS_PLANKS_OAK.getDefaultStack());
             slabsStackList.add(Blocks.SLAB_PLANKS_OAK.getDefaultStack());
@@ -103,6 +107,8 @@ public class Registries extends Registry<Registry<?>>
 
             for (DyeColor color : DyeColor.values()) {
                 plankStackList.add(new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, color.blockMeta));
+                signStackList.add(new ItemStack(Items.SIGN_PAINTED, 1, color.itemMeta));
+                doorStackList.add(new ItemStack(Items.DOOR_OAK_PAINTED, 1, color.itemMeta));
                 chestStackList.add(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
                 stairsStackList.add(new ItemStack(Blocks.STAIRS_PLANKS_PAINTED, 1, color.blockMeta << 4));
                 slabsStackList.add(new ItemStack(Blocks.SLAB_PLANKS_PAINTED, 1, color.blockMeta << 4));
@@ -114,6 +120,8 @@ public class Registries extends Registry<Registry<?>>
                 invertedLampStackList.add(new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
             }
             ITEM_GROUPS.register("minecraft:planks",plankStackList);
+            ITEM_GROUPS.register("minecraft:signs",signStackList);
+            ITEM_GROUPS.register("minecraft:doors",doorStackList);
             ITEM_GROUPS.register("minecraft:chests", chestStackList);
             ITEM_GROUPS.register("minecraft:wools", woolStackList);
             ITEM_GROUPS.register("minecraft:lamps", lampStackList);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index fbeb64774..48348524d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
@@ -279,9 +280,9 @@ public class MobGhast extends MobFlying
     {
         return
             this.world.getDifficulty().canHostileMobsSpawn() &&
-            this.random.nextInt(20) == 0 &&
-            BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z))) &&
-            super.canSpawnHere();
+                this.random.nextInt(20) == 0 &&
+                BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(MathHelper.floor(this.x), MathHelper.floor(this.y - this.heightOffset) - 1, MathHelper.floor(this.z))) &&
+                super.canSpawnHere();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index f35052c80..befe891c9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -340,26 +340,13 @@ public abstract class Player
     @Override
 	public void rideTick()
     {
-        final double xdO = this.xd;
-        final double ydO = this.yd;
-        final double zdO = this.zd;
-        final double xo = this.x;
-        final double yo = this.y;
-        final double zo = this.z;
+        double xdO = x;
+        double ydO = y;
+        double zdO = z;
         super.rideTick();
-        this.cameraVelocityOld = this.cameraVelocity;
-        this.cameraVelocity = 0.0F;
-        addMountedMovementStat(this.x - xo, this.y - yo, this.z - zo);
-
-        if (this.vehicle instanceof Entity) {
-            this.xd = ((Entity) this.vehicle).xd;
-            this.yd = ((Entity) this.vehicle).yd;
-            this.zd = ((Entity) this.vehicle).zd;
-        }
-
-        this.xdO = xdO;
-        this.ydO = ydO;
-        this.zdO = zdO;
+        cameraVelocityOld = cameraVelocity;
+        cameraVelocity = 0.0F;
+        addMountedMovementStat(x - xdO, y - ydO, z - zdO);
     }
 
     @Override
@@ -808,6 +795,7 @@ public abstract class Player
 	public void readAdditionalSaveData(@NotNull CompoundTag tag)
     {
         super.readAdditionalSaveData(tag);
+        nickname = nickname.replace(" ", "");
         ListTag nbttaglist = tag.getList("Inventory");
         inventory.readFromNBT(nbttaglist);
         inventory.setCurrentItemIndex(tag.getIntegerOrDefault("CurrentItem", inventory.getCurrentItemIndex()), true);
@@ -1638,7 +1626,7 @@ public abstract class Player
             tileEntity.writeAdditionalData(entityTag);
             selectItem.getData().put("tileEntityData", entityTag);
         }
-    	
+
 		//Find item in hotbar, and select it
 		for(int i=0; i < 9; i++) {
 			ItemStack stack = inventory.getItem(i + inventory.getHotbarOffset());
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
index 2dcb5d22a..8ed5c35d5 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
@@ -82,7 +82,7 @@ public class ProjectileFireball extends Projectile
                     } else {
                         result.entity.hurt(owner, damage, DamageType.COMBAT);
                     }
-                    if (owner instanceof Player) {
+                    if (result.entity instanceof Mob && owner instanceof Player) {
                         ((Player) owner).addStat(Achievements.HIT_FIREBALL, 1);
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java b/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
index 1b342c853..abd5d27ef 100644
--- a/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
+++ b/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
@@ -2,47 +2,51 @@ package net.minecraft.core.enums;
 
 public enum EnumSignPicture
 {
-    NONE            (0,  "sign.image.none",          "minecraft:sign/none"),
-    ARROW_RIGHT     (1,  "sign.image.arrow_right",   "minecraft:sign/arrow_right"),
-    ARROW_LEFT      (2,  "sign.image.arrow_left",    "minecraft:sign/arrow_left"),
-    ARROW_DOWN      (3,  "sign.image.arrow_down",    "minecraft:sign/arrow_down"),
-    ARROW_UP        (4,  "sign.image.arrow_up",      "minecraft:sign/arrow_up"),
-    CAUTION         (5,  "sign.image.caution",       "minecraft:sign/caution"),
-    MOBS            (6,  "sign.image.mobs",          "minecraft:sign/mobs"),
-    TREES           (7,  "sign.image.trees",         "minecraft:sign/trees"),
-    CHEST           (8,  "sign.image.chest",         "minecraft:sign/chest"),
-    PICKAXE         (9,  "sign.image.pickaxe",       "minecraft:sign/pickaxe"),
-    WOLF            (10, "sign.image.wolf",          "minecraft:sign/wolf"),
-    SWORD           (11, "sign.image.sword",         "minecraft:sign/sword"),
-    HOE             (12, "sign.image.hoe",           "minecraft:sign/hoe"),
-    AXE             (13, "sign.image.axe",           "minecraft:sign/axe"),
-    SHOVEL          (14, "sign.image.shovel",        "minecraft:sign/shovel"),
-    BOWL            (15, "sign.image.bowl",          "minecraft:sign/bowl"),
-    TNT             (16, "sign.image.tnt",           "minecraft:sign/tnt"),
-    MOB_FARM        (17, "sign.image.mob_farm",      "minecraft:sign/mob_farm"),
-    MINE            (18, "sign.image.mine",          "minecraft:sign/mine"),
-    REDSTONE        (19, "sign.image.redstone",      "minecraft:sign/redstone"),
-    FARM            (20, "sign.image.farm",          "minecraft:sign/farm"),
-    BARRICADE       (21, "sign.image.barricade",     "minecraft:sign/barricade"),
-    QUESTION_MARK   (22, "sign.image.question_mark", "minecraft:sign/question_mark"),
-    FACE_SMILE      (23, "sign.image.face_smile",    "minecraft:sign/face_smile"),
-    FACE_SAD        (24, "sign.image.face_sad",      "minecraft:sign/face_sad"),
-    FACE_CRYING     (25, "sign.image.face_crying",   "minecraft:sign/face_crying"),
-    FACE_GASP       (26, "sign.image.face_gasp",     "minecraft:sign/face_gasp"),
-    FACE_THINKING   (27, "sign.image.face_thinking", "minecraft:sign/face_thinking"),
-    FACE_CONFUSED   (28, "sign.image.face_confused", "minecraft:sign/face_confused"),
-    BIG_SIGN        (29, "sign.image.big_sign",      "minecraft:sign/big_sign"),
-    MOB_ZOMBIE      (30, "sign.image.mob_zombie",    "minecraft:sign/mob_zombie"),
-    MOB_SKELETON    (31, "sign.image.mob_skeleton",  "minecraft:sign/mob_skeleton"),
-    MOB_CREEPER     (32, "sign.image.mob_creeper",   "minecraft:sign/mob_creeper"),
-    ONE_PLAYER      (33, "sign.image.one_player",    "minecraft:sign/one_player"),
-    TWO_PLAYERS     (34, "sign.image.two_players",   "minecraft:sign/two_players"),
-    THREE_PLAYERS   (35, "sign.image.three_players", "minecraft:sign/three_players"),
-    CROSS           (36, "sign.image.cross",         "minecraft:sign/cross"),
-    CRAFT           (37, "sign.image.craft",         "minecraft:sign/craft"),
-    AFK             (38, "sign.image.afk",           "minecraft:sign/afk"),
-    BRB             (39, "sign.image.brb",           "minecraft:sign/brb"),
-    HEART           (40, "sign.image.heart",         "minecraft:sign/heart");
+    NONE                (0,  "sign.image.none",             "minecraft:sign/none"),
+    ARROW_RIGHT         (1,  "sign.image.arrow_right",      "minecraft:sign/arrow_right"),
+    ARROW_LEFT          (2,  "sign.image.arrow_left",       "minecraft:sign/arrow_left"),
+    ARROW_DOWN          (3,  "sign.image.arrow_down",       "minecraft:sign/arrow_down"),
+    ARROW_UP            (4,  "sign.image.arrow_up",         "minecraft:sign/arrow_up"),
+    CAUTION             (5,  "sign.image.caution",          "minecraft:sign/caution"),
+    MOBS                (6,  "sign.image.mobs",             "minecraft:sign/mobs"),
+    TREES               (7,  "sign.image.trees",            "minecraft:sign/trees"),
+    CHEST               (8,  "sign.image.chest",            "minecraft:sign/chest"),
+    PICKAXE             (9,  "sign.image.pickaxe",          "minecraft:sign/pickaxe"),
+    WOLF                (10, "sign.image.wolf",             "minecraft:sign/wolf"),
+    SWORD               (11, "sign.image.sword",            "minecraft:sign/sword"),
+    HOE                 (12, "sign.image.hoe",              "minecraft:sign/hoe"),
+    AXE                 (13, "sign.image.axe",              "minecraft:sign/axe"),
+    SHOVEL              (14, "sign.image.shovel",           "minecraft:sign/shovel"),
+    BOWL                (15, "sign.image.bowl",             "minecraft:sign/bowl"),
+    TNT                 (16, "sign.image.tnt",              "minecraft:sign/tnt"),
+    MOB_FARM            (17, "sign.image.mob_farm",         "minecraft:sign/mob_farm"),
+    MINE                (18, "sign.image.mine",             "minecraft:sign/mine"),
+    REDSTONE            (19, "sign.image.redstone",         "minecraft:sign/redstone"),
+    FARM                (20, "sign.image.farm",             "minecraft:sign/farm"),
+    BARRICADE           (21, "sign.image.barricade",        "minecraft:sign/barricade"),
+    QUESTION_MARK       (22, "sign.image.question_mark",    "minecraft:sign/question_mark"),
+    FACE_SMILE          (23, "sign.image.face_smile",       "minecraft:sign/face_smile"),
+    FACE_SAD            (24, "sign.image.face_sad",         "minecraft:sign/face_sad"),
+    FACE_CRYING         (25, "sign.image.face_crying",      "minecraft:sign/face_crying"),
+    FACE_GASP           (26, "sign.image.face_gasp",        "minecraft:sign/face_gasp"),
+    FACE_THINKING       (27, "sign.image.face_thinking",    "minecraft:sign/face_thinking"),
+    FACE_CONFUSED       (28, "sign.image.face_confused",    "minecraft:sign/face_confused"),
+    BIG_SIGN            (29, "sign.image.big_sign",         "minecraft:sign/big_sign"),
+    MOB_ZOMBIE          (30, "sign.image.mob_zombie",       "minecraft:sign/mob_zombie"),
+    MOB_SKELETON        (31, "sign.image.mob_skeleton",     "minecraft:sign/mob_skeleton"),
+    MOB_CREEPER         (32, "sign.image.mob_creeper",      "minecraft:sign/mob_creeper"),
+    ONE_PLAYER          (33, "sign.image.one_player",       "minecraft:sign/one_player"),
+    TWO_PLAYERS         (34, "sign.image.two_players",      "minecraft:sign/two_players"),
+    THREE_PLAYERS       (35, "sign.image.three_players",    "minecraft:sign/three_players"),
+    CROSS               (36, "sign.image.cross",            "minecraft:sign/cross"),
+    CRAFT               (37, "sign.image.craft",            "minecraft:sign/craft"),
+    AFK                 (38, "sign.image.afk",              "minecraft:sign/afk"),
+    BRB                 (39, "sign.image.brb",              "minecraft:sign/brb"),
+    HEART               (40, "sign.image.heart",            "minecraft:sign/heart"),
+    ARROWS_LEFT_RIGHT   (41, "sign.image.arrows_left_right","minecraft:sign/arrows_left_right"),
+    ARROWS_UP_DOWN      (42, "sign.image.arrows_up_down",   "minecraft:sign/arrows_up_down"),
+    CHECK               (43, "sign.image.check",            "minecraft:sign/check"),
+    EXIT                (44, "sign.image.exit",             "minecraft:sign/exit");
 
     private final int id;
     private final String languageKey;
